from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

T = TypeVar("T", bound="GetAccessTokenInfoResponse")


@_attrs_define
class GetAccessTokenInfoResponse:
    """
    Example:
        {'audience': 'b0601394-d106-4bca-a825-af40b7422640', 'user_id': 'b0601394-d106-4bca-a825-af40b7422640',
            'expires_in': 15951}

    Attributes:
        audience (str):  Example: b0601394-d106-4bca-a825-af40b7422640.
        user_id (str):  Example: b0601394-d106-4bca-a825-af40b7422640.
        expires_in (int):  Example: 15951.
    """

    audience: str
    user_id: str
    expires_in: int
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        audience = self.audience

        user_id = self.user_id

        expires_in = self.expires_in

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "audience": audience,
                "user_id": user_id,
                "expires_in": expires_in,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        audience = d.pop("audience")

        user_id = d.pop("user_id")

        expires_in = d.pop("expires_in")

        get_access_token_info_response = cls(
            audience=audience,
            user_id=user_id,
            expires_in=expires_in,
        )

        get_access_token_info_response.additional_properties = d
        return get_access_token_info_response

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
